; Regulator obcienia sieciowego
; Rafa Baranowski (C) 2005

.INCLUDE "tn26def.inc"		; SEGMENT DEKLARACJI

.EQU	SYS_FREQ	= 1		; czstotliwo systemowa wynosi 1 MHz
					; stae klawiatury
.EQU	K_KLAW	= DDRA	;   rejestr kierunku portu klawiatury
.EQU	O_KLAW	= PORTA	;   rejestr wyjciowy portu klawiatury
.EQU	I_KLAW	= PINA	;   rejestr wejciowy portu klawiatury
.EQU	KL_A		= 0		;   nr linii dla sygnau klawisza A
.EQU	KL_B		= 1		;   nr linii dla sygnau klawisza B
					; stae regulatora
.EQU	K_REGUL	= DDRB	;   rejestr kierunku portu regulatora
.EQU	O_REGUL	= PORTB	;   rejestr wyjciowy portu regulatora
.EQU	I_REGUL	= PINB	;   rejestr wejciowy portu regulatora
.EQU	REG_PWM2	= 3		;   nr linii dla sygnau "PWM2" (OC1B)
.EQU	REG_ZCD	= 6		;   nr linii dla sygnau "ZCD" (INT0)

.DSEG					; SEGMENT DANYCH
.ORG	0x0060			; pocztek pamici SRAM
Jasnosc:	.BYTE	1		; deklaracja zmiennej bajtowej "Jasnosc" w pamici SRAM


.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	rjmp	Reset			; skocz do procedury inicjalizujcej

.ORG	INT0addr			; wektor przerwania INT0
	rjmp	Szczyt_zasilania	; skocz do procedury obsugujcej szczyt zasilania

.ORG	OVF1addr			; wektor przerwania TOV1
	rjmp	Zero_zasilania	; skocz do procedury obsugujcej zero zasilania


Reset:				; podprogram inicjalizujcy
	ldi	R16, RAMEND
	out	SP, R16		; inicjalizuj wskanik stosu

	ldi	R16, (1<<KL_A)|(1<<KL_B)
	out	O_KLAW, R16		; wcz podciganie na liniach klawiatury

	rcall	Ini_regulatora	; zainicjalizuj regulator

	sei				; odblokuj przerwania

Petla:				; ptla gwna programu
	sbic	I_KLAW, KL_A
	rjmp	Petla_kl_B
					; jeli nacinito klawisz A, to...
	lds	R16, Jasnosc	;   odczytaj zawarto zmiennej "Jasnosc"
	inc	R16			;   i inkrementuj j
	cpi	R16, 156
	brlo	Petla_kl_A1		;   jeli inkrementowano powyej 155, to...
	ldi	R16, 155		;     zmniejsz "Jasnosc" do 155
Petla_kl_A1:
	sts	Jasnosc, R16	;   i zapamitaj zmodyfikowan "Jasnosc"

	ldi	R16, 20
	ldi	R17, 1
	rcall	Czekaj_ms		; wywoaj procedur opniajc (t=1*20 ms)

Petla_kl_B:
	sbic	I_KLAW, KL_B	
	rjmp	Petla
					; jeli nacinito klawisz B, to...
	lds	R16, Jasnosc	;   odczytaj zawarto zmiennej "Jasnosc"
	dec	R16			;   i dekrementuj j
	cpi	R16, 156
	brlo	Petla_kl_B1		;   jeli dekrementowano poniej zera, to...
	clr	R16			;     ustal "Jasnosc" na 0
Petla_kl_B1:
	sts	Jasnosc, R16	;   i zapamitaj zmodyfikowan "Jasnosc"

	ldi	R16, 20
	ldi	R17, 1
	rcall	Czekaj_ms		; wywoaj procedur opniajc (t=1*20 ms)

	rjmp	Petla			; zaptl program


					; DOCZANE PODPROGRAMY
.INCLUDE "czekaj_ms.inc"	;   oczekiwanie milisekundowe
.INCLUDE "reg_siec.inc"		;   regulator sieciowy
